Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Imports SMD2XX
Imports SelectDevice

Namespace Segment_Test

	Public Partial Class Form1
		Inherits Form

		#Region "intialization"
		Private ftStatus As FT_STATUS = 0
		Private ftHandle As UInt32 = 0

		Private SM As SM_D2XX = New SM_D2XX()

		Private dev As Select_Device = New Select_Device()

		Private Output As Byte = 0
		Public Sub New()
			InitializeComponent()
		End Sub
		#End Region

		#Region "Segment Buttons"
		Private Sub buttona_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttona.Click
			If buttona.BackColor = Color.LightGray Then
				buttona.BackColor = Color.Red
                Output += &H1
			Else
				buttona.BackColor = Color.LightGray
				If Output >= &H01 Then
				Output -= &H01
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttonb_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonb.Click
			If buttonb.BackColor = Color.LightGray Then
				buttonb.BackColor = Color.Red
				Output += &H02
			Else
				buttonb.BackColor = Color.LightGray
				If Output >= &H02 Then
				Output -= &H02
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttonc_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonc.Click
			If buttonc.BackColor = Color.LightGray Then
				buttonc.BackColor = Color.Red
				Output += &H04
			Else
				buttonc.BackColor = Color.LightGray
				If Output >= &H04 Then
				Output -= &H04
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttond_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttond.Click
			If buttond.BackColor = Color.LightGray Then
				buttond.BackColor = Color.Red
				Output += &H08
			Else
				buttond.BackColor = Color.LightGray
				If Output >= &H08 Then
				Output -= &H08
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttone_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttone.Click
			If buttone.BackColor = Color.LightGray Then
				buttone.BackColor = Color.Red
				Output += &H10
			Else
				buttone.BackColor = Color.LightGray
				If Output >= &H10 Then
				Output -= &H10
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttonf_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonf.Click
			If buttonf.BackColor = Color.LightGray Then
				buttonf.BackColor = Color.Red
				Output += &H20
			Else
				buttonf.BackColor = Color.LightGray
				If Output >= &H20 Then
				Output -= &H20
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttong_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttong.Click
			If buttong.BackColor = Color.LightGray Then
				buttong.BackColor = Color.Red
				Output += &H40
			Else
				buttong.BackColor = Color.LightGray
				If Output >= &H40 Then
				Output -= &H40
				End If
			End If

			bitBangOutD(Output)
		End Sub

		Private Sub buttondp_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttondp.Click
			If buttondp.BackColor = Color.LightGray Then
				buttondp.BackColor = Color.Red
				Output += &H80
			Else
				buttondp.BackColor = Color.LightGray
				If Output >= &H80 Then
				Output -= &H80
				End If
			End If

			bitBangOutD(Output)
		End Sub
		#End Region

		#Region "Select and Open a Device"

		Private Sub selectDeviceToolStripMenuItem_Click_1(ByVal sender As Object, ByVal e As EventArgs) Handles selectDeviceToolStripMenuItem.Click
			dev.ShowDialog()

			Select Case dev.OpenBy
                Case CUInt(OPEN_BY.SERIAL_NUMBER) ' use OpenEX
                    openBySerialNumber(dev.SerialNumber)
                Case CUInt(OPEN_BY.DESCRIPTION) ' use OpenEX
                    openByDescription(dev.Description)
                Case CUInt(OPEN_BY.LOCATIONID) ' use OpenEX
                    openByLocationID(dev.LocID)
				Case Else
					MessageBox.Show("ERROR - OpenBy = " & dev.OpenBy.ToString())
			End Select
		End Sub

		' open by serial number
		Private Sub openBySerialNumber(ByVal SN As String)
			ftStatus = SM.openSerialNumber(SN, ftHandle)
			If ftStatus <> FT_STATUS.FT_OK Then
				MessageBox.Show("Error: buttonGet_Click failed to open device")
			End If
		End Sub

		' open by description
		Private Sub openByDescription(ByVal description As String)
			ftStatus = SM.openDescription(description, ftHandle)
			If ftStatus <> FT_STATUS.FT_OK Then
				MessageBox.Show("Error: buttonGet_Click failed to open port")
			End If
		End Sub

		' open by location
		Private Sub openByLocationID(ByVal locID As UInt32)
			ftStatus = SM.openLocationID(locID, ftHandle)
			If ftStatus <> FT_STATUS.FT_OK Then
				MessageBox.Show("Error: buttonGet_Click failed to open port")
			End If
		End Sub

		' Assumes device is open
		Private Sub closeDevice()
			SM.closeDevice(ftHandle)
		End Sub

		#End Region

		#Region "Bit-bang Output"

		Private Sub bitBangOutD(ByVal Out As Byte)
			SM.bitBang_SetBitMode(ftHandle, Out, &H01)
		End Sub

		#End Region

        Private myFont As Byte() = New Byte(36) {&H77, &H7C, &H39, &H5E, &H79, &H71, &H6F, &H76, &H30, &H1E, &H70, &H38, &H15, &H54, &H3F, &H73, &H67, &H50, &H6D, &H78, &H3E, &H1C, &H2A, &H46, &H6E, &H52, &H3F, &H6, &H5B, &H4F, &H66, &H6D, &H7D, &H7, &H7F, &H6F, &H8}

		#Region "Font Buttons"

		Private A As Byte = &H77
		Private B As Byte = &H7C
		Private C As Byte = &H39
		Private D As Byte = &H5E
		Private E As Byte = &H79
		Private F As Byte = &H71
		Private G As Byte = &H6F
		Private H As Byte = &H76
		Private I As Byte = &H30
		Private J As Byte = &H1E
		Private K As Byte = &H70
		Private L As Byte = &H38
		Private M As Byte = &H15
		Private N As Byte = &H54
		Private O As Byte = &H3F
		Private P As Byte = &H73
		Private Q As Byte = &H67
		Private R As Byte = &H50
		Private S As Byte = &H6D
		Private T As Byte = &H78
		Private U As Byte = &H3E
		Private V As Byte = &H1C
		Private W As Byte = &H2A
		Private X As Byte = &H46
		Private Y As Byte = &H6E
		Private Z As Byte = &H52
		Private F0 As Byte = &H3F
		Private F1 As Byte = &H06
		Private F2 As Byte = &H5B
		Private F3 As Byte = &H4F
		Private F4 As Byte = &H66
		Private F5 As Byte = &H6D
		Private F6 As Byte = &H7D
		Private F7 As Byte = &H07
		Private F8 As Byte = &H7F
		Private F9 As Byte = &H6F
		'private byte SP = 0x08; // show space as segment d
		'private byte vd = 0x00; // show no segments

		Private Sub buttonFontA_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontA.Click
			bitBangOutD(A)
		End Sub

		Private Sub buttonFontB_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontB.Click
			bitBangOutD(B)
		End Sub

		Private Sub buttonFontC_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontC.Click
			bitBangOutD(C)
		End Sub

		Private Sub buttonFontD_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontD.Click
			bitBangOutD(D)
		End Sub

		Private Sub buttonFontE_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontE.Click
			bitBangOutD(Me.E)
		End Sub

		Private Sub buttonFontF_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontF.Click
			bitBangOutD(F)
		End Sub

		Private Sub buttonFontG_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontG.Click
			bitBangOutD(G)
		End Sub

		Private Sub buttonFontH_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontH.Click
			bitBangOutD(H)
		End Sub

		Private Sub buttonFontI_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontI.Click
			bitBangOutD(I)
		End Sub

		Private Sub buttonFontJ_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontJ.Click
			bitBangOutD(J)
		End Sub

		Private Sub buttonFontK_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontK.Click
			bitBangOutD(K)
		End Sub

		Private Sub buttonFontL_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontL.Click
			bitBangOutD(L)
		End Sub

		Private Sub buttonFontM_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontM.Click
			bitBangOutD(M)
		End Sub

		Private Sub buttonFontN_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontN.Click
			bitBangOutD(N)
		End Sub

		Private Sub buttonFontO_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontO.Click
			bitBangOutD(O)
		End Sub

		Private Sub buttonFontP_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontP.Click
			bitBangOutD(P)
		End Sub

		Private Sub buttonFontQ_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontQ.Click
			bitBangOutD(Q)
		End Sub

		Private Sub buttonFontR_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontR.Click
			bitBangOutD(R)
		End Sub

		Private Sub buttonFontS_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontS.Click
			bitBangOutD(S)
		End Sub

		Private Sub buttonFontT_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontT.Click
			bitBangOutD(T)
		End Sub

		Private Sub buttonFontU_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontU.Click
			bitBangOutD(U)
		End Sub

		Private Sub buttonFontV_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontV.Click
			bitBangOutD(V)
		End Sub

		Private Sub buttonFontW_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontW.Click
			bitBangOutD(W)
		End Sub

		Private Sub buttonFontX_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontX.Click
			bitBangOutD(X)
		End Sub

		Private Sub buttonFontY_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontY.Click
			bitBangOutD(Y)
		End Sub

		Private Sub buttonFontZ_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFontZ.Click
			bitBangOutD(Z)
		End Sub

		Private Sub buttonFont0_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont0.Click
			bitBangOutD(F0)
		End Sub

		Private Sub buttonFont1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont1.Click
			bitBangOutD(F1)
		End Sub

		Private Sub buttonFont2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont2.Click
			bitBangOutD(F2)
		End Sub

		Private Sub buttonFont3_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont3.Click
			bitBangOutD(F3)
		End Sub

		Private Sub buttonFont4_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont4.Click
			bitBangOutD(F4)
		End Sub

		Private Sub buttonFont5_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont5.Click
			bitBangOutD(F5)
		End Sub

		Private Sub buttonFont6_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont6.Click
			bitBangOutD(F6)
		End Sub

		Private Sub buttonFont7_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont7.Click
			bitBangOutD(F7)
		End Sub

		Private Sub buttonFont8_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont8.Click
			bitBangOutD(F8)
		End Sub

		Private Sub buttonFont9_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonFont9.Click
			bitBangOutD(F9)
		End Sub

		#End Region

		#Region "Tests"

		Private count As Byte = 0
		Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer1.Tick
            bitBangOutD(myFont(count))
            count += Convert.ToByte(1)
			If count >= 36 Then
			count = 0
			End If
		End Sub

		Private Sub buttonShowFont_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonShowFont.Click
			If timer1.Enabled Then
				timer1.Enabled = False
				buttonShowFont.Text = "Show Font"
			Else
					timer1.Enabled = True
					buttonShowFont.Text = "Stop Font"
			End If
		End Sub

		Private outCount As Integer = 0
		Private outStr As Byte() = New Byte(127){} ' 64 characters = 64 voids

		Private hello As Boolean = True
		Private Sub buttonHello_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonHello.Click
			If hello Then
				hello = False
				buttonHello.Text = "Stop Hello"
				sendtStringTo7SegOutput("Hello World")
			Else
				timer2.Enabled = False
				hello = True
				buttonHello.Text = "Hello World"
			End If
		End Sub

		Private sendTxt As Boolean = True
		Private Sub buttonSendText_Click(ByVal sender As Object, ByVal e As EventArgs) Handles buttonSendText.Click
			If sendTxt Then
				sendTxt = False
				buttonSendText.Text = "Stop Text"
				sendtStringTo7SegOutput(textBoxSendText.Text)
			Else
				timer2.Enabled = False
				sendTxt = True
				buttonSendText.Text = "Send Text"
			End If
		End Sub

		Private Sub sendtStringTo7SegOutput(ByVal str As String)
			timer2.Enabled = False
			timerCount = 0
			outCount = 0
			Dim temp As Integer = 0
			For Each s As Byte In outStr
			outStr(temp) = 0
			temp += 1
			Next s

			' convert string to upper case
			str = str.ToUpper()

			' put it in an array
			Dim charStr As Char() = str.ToCharArray()

			Dim b As Byte = 0
			Dim strCount As Integer = 0
			For Each c As Char In charStr
                outCount += 1
                If outCount > 64 Then
                    MessageBox.Show("Out string cannot have > 64 characters")
                    Exit For
                End If

                b = Convert.ToByte(c)

                If b = 32 Then ' 32 is ASCII code for a space character
                    outStr(strCount) = &H8
                    strCount += 1
                    outStr(strCount) = &H0
                    strCount += 1
                    outCount += 1 ' increase count for added voids
                Else
                    If (b > 64) AndAlso (b < 91) Then 'filter for capital letters only
                        b -= Convert.ToByte(65) ' it is a character
                        outStr(strCount) += myFont(b)
                        strCount += 1
                        outStr(strCount) = &H0
                        strCount += 1
                        outCount += 1 ' increase count for added voids
                    ElseIf (b > 47) AndAlso (b < 58) Then ' filter for numerals
                        b -= Convert.ToByte((48 - 26)) ' it is a number - numbers start a 26 in font array
                        outStr(strCount) += myFont(b)
                        strCount += 1
                        outStr(strCount) = &H0
                        strCount += 1
                        outCount += 1 ' increase count for added voids
                    End If
                End If
            Next c
			timer2.Enabled = True
		End Sub

		Private timerCount As Integer = 0
		Private Sub timer2_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles timer2.Tick
			bitBangOutD(outStr(timerCount))
			timerCount += 1
			If timerCount > outCount Then
			timerCount = 0
			End If
		End Sub

		Private Sub buttonstopText_Click(ByVal sender As Object, ByVal e As EventArgs)
			Dim temp As Integer = 0
			For Each b As Byte In outStr
			outStr(temp) = 0
			temp += 1
			Next b
			timer2.Enabled = False
		End Sub

		#End Region
	End Class
End Namespace

